// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: stateMachineServices.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// StateMachineServiceClient is the client API for StateMachineService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type StateMachineServiceClient interface {
	Create(ctx context.Context, in *StateMachine, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *StateMachine, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*StateMachine, error)
	Export(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*StateMachineExport, error)
	List(ctx context.Context, in *proto.ListOptions, opts ...grpc.CallOption) (*StateMachineResp, error)
	Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error)
}

type stateMachineServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewStateMachineServiceClient(cc grpc.ClientConnInterface) StateMachineServiceClient {
	return &stateMachineServiceClient{cc}
}

func (c *stateMachineServiceClient) Create(ctx context.Context, in *StateMachine, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateMachineServiceClient) Update(ctx context.Context, in *StateMachine, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateMachineServiceClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateMachineServiceClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*StateMachine, error) {
	out := new(StateMachine)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateMachineServiceClient) Export(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*StateMachineExport, error) {
	out := new(StateMachineExport)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/Export", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateMachineServiceClient) List(ctx context.Context, in *proto.ListOptions, opts ...grpc.CallOption) (*StateMachineResp, error) {
	out := new(StateMachineResp)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/List", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateMachineServiceClient) Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error) {
	out := new(proto.UInt64Value)
	err := c.cc.Invoke(ctx, "/botMs.StateMachineService/Count", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// StateMachineServiceServer is the server API for StateMachineService service.
// All implementations must embed UnimplementedStateMachineServiceServer
// for forward compatibility
type StateMachineServiceServer interface {
	Create(context.Context, *StateMachine) (*proto.IdRequest, error)
	Update(context.Context, *StateMachine) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*StateMachine, error)
	Export(context.Context, *proto.IdRequest) (*StateMachineExport, error)
	List(context.Context, *proto.ListOptions) (*StateMachineResp, error)
	Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error)
	mustEmbedUnimplementedStateMachineServiceServer()
}

// UnimplementedStateMachineServiceServer must be embedded to have forward compatible implementations.
type UnimplementedStateMachineServiceServer struct {
}

func (UnimplementedStateMachineServiceServer) Create(context.Context, *StateMachine) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedStateMachineServiceServer) Update(context.Context, *StateMachine) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedStateMachineServiceServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedStateMachineServiceServer) Get(context.Context, *proto.IdRequest) (*StateMachine, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedStateMachineServiceServer) Export(context.Context, *proto.IdRequest) (*StateMachineExport, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Export not implemented")
}
func (UnimplementedStateMachineServiceServer) List(context.Context, *proto.ListOptions) (*StateMachineResp, error) {
	return nil, status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedStateMachineServiceServer) Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Count not implemented")
}
func (UnimplementedStateMachineServiceServer) mustEmbedUnimplementedStateMachineServiceServer() {}

// UnsafeStateMachineServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to StateMachineServiceServer will
// result in compilation errors.
type UnsafeStateMachineServiceServer interface {
	mustEmbedUnimplementedStateMachineServiceServer()
}

func RegisterStateMachineServiceServer(s grpc.ServiceRegistrar, srv StateMachineServiceServer) {
	s.RegisterService(&StateMachineService_ServiceDesc, srv)
}

func _StateMachineService_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StateMachine)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).Create(ctx, req.(*StateMachine))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateMachineService_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StateMachine)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).Update(ctx, req.(*StateMachine))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateMachineService_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateMachineService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateMachineService_Export_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).Export(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/Export",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).Export(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateMachineService_List_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.ListOptions)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).List(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/List",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).List(ctx, req.(*proto.ListOptions))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateMachineService_Count_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateMachineServiceServer).Count(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateMachineService/Count",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateMachineServiceServer).Count(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// StateMachineService_ServiceDesc is the grpc.ServiceDesc for StateMachineService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var StateMachineService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.StateMachineService",
	HandlerType: (*StateMachineServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _StateMachineService_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _StateMachineService_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _StateMachineService_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _StateMachineService_Get_Handler,
		},
		{
			MethodName: "Export",
			Handler:    _StateMachineService_Export_Handler,
		},
		{
			MethodName: "List",
			Handler:    _StateMachineService_List_Handler,
		},
		{
			MethodName: "Count",
			Handler:    _StateMachineService_Count_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "stateMachineServices.proto",
}

// StateServiceClient is the client API for StateService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type StateServiceClient interface {
	Create(ctx context.Context, in *State, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *State, opts ...grpc.CallOption) (*emptypb.Empty, error)
	BatchUpdate(ctx context.Context, in *StateBatch, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*State, error)
	List(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (StateService_ListClient, error)
}

type stateServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewStateServiceClient(cc grpc.ClientConnInterface) StateServiceClient {
	return &stateServiceClient{cc}
}

func (c *stateServiceClient) Create(ctx context.Context, in *State, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.StateService/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateServiceClient) Update(ctx context.Context, in *State, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.StateService/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateServiceClient) BatchUpdate(ctx context.Context, in *StateBatch, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.StateService/BatchUpdate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateServiceClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.StateService/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateServiceClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*State, error) {
	out := new(State)
	err := c.cc.Invoke(ctx, "/botMs.StateService/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *stateServiceClient) List(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (StateService_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &StateService_ServiceDesc.Streams[0], "/botMs.StateService/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &stateServiceListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type StateService_ListClient interface {
	Recv() (*State, error)
	grpc.ClientStream
}

type stateServiceListClient struct {
	grpc.ClientStream
}

func (x *stateServiceListClient) Recv() (*State, error) {
	m := new(State)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// StateServiceServer is the server API for StateService service.
// All implementations must embed UnimplementedStateServiceServer
// for forward compatibility
type StateServiceServer interface {
	Create(context.Context, *State) (*proto.IdRequest, error)
	Update(context.Context, *State) (*emptypb.Empty, error)
	BatchUpdate(context.Context, *StateBatch) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*State, error)
	List(*proto.IdRequest, StateService_ListServer) error
	mustEmbedUnimplementedStateServiceServer()
}

// UnimplementedStateServiceServer must be embedded to have forward compatible implementations.
type UnimplementedStateServiceServer struct {
}

func (UnimplementedStateServiceServer) Create(context.Context, *State) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedStateServiceServer) Update(context.Context, *State) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedStateServiceServer) BatchUpdate(context.Context, *StateBatch) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchUpdate not implemented")
}
func (UnimplementedStateServiceServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedStateServiceServer) Get(context.Context, *proto.IdRequest) (*State, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedStateServiceServer) List(*proto.IdRequest, StateService_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedStateServiceServer) mustEmbedUnimplementedStateServiceServer() {}

// UnsafeStateServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to StateServiceServer will
// result in compilation errors.
type UnsafeStateServiceServer interface {
	mustEmbedUnimplementedStateServiceServer()
}

func RegisterStateServiceServer(s grpc.ServiceRegistrar, srv StateServiceServer) {
	s.RegisterService(&StateService_ServiceDesc, srv)
}

func _StateService_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(State)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateServiceServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateService/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateServiceServer).Create(ctx, req.(*State))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateService_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(State)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateServiceServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateService/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateServiceServer).Update(ctx, req.(*State))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateService_BatchUpdate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StateBatch)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateServiceServer).BatchUpdate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateService/BatchUpdate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateServiceServer).BatchUpdate(ctx, req.(*StateBatch))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateService_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateServiceServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateService/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateServiceServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(StateServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.StateService/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(StateServiceServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _StateService_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(proto.IdRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(StateServiceServer).List(m, &stateServiceListServer{stream})
}

type StateService_ListServer interface {
	Send(*State) error
	grpc.ServerStream
}

type stateServiceListServer struct {
	grpc.ServerStream
}

func (x *stateServiceListServer) Send(m *State) error {
	return x.ServerStream.SendMsg(m)
}

// StateService_ServiceDesc is the grpc.ServiceDesc for StateService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var StateService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.StateService",
	HandlerType: (*StateServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _StateService_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _StateService_Update_Handler,
		},
		{
			MethodName: "BatchUpdate",
			Handler:    _StateService_BatchUpdate_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _StateService_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _StateService_Get_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _StateService_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "stateMachineServices.proto",
}

// TransitionServiceClient is the client API for TransitionService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type TransitionServiceClient interface {
	Create(ctx context.Context, in *Transition, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *Transition, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*Transition, error)
	List(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (TransitionService_ListClient, error)
}

type transitionServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewTransitionServiceClient(cc grpc.ClientConnInterface) TransitionServiceClient {
	return &transitionServiceClient{cc}
}

func (c *transitionServiceClient) Create(ctx context.Context, in *Transition, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.TransitionService/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transitionServiceClient) Update(ctx context.Context, in *Transition, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.TransitionService/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transitionServiceClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.TransitionService/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transitionServiceClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*Transition, error) {
	out := new(Transition)
	err := c.cc.Invoke(ctx, "/botMs.TransitionService/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *transitionServiceClient) List(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (TransitionService_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &TransitionService_ServiceDesc.Streams[0], "/botMs.TransitionService/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &transitionServiceListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type TransitionService_ListClient interface {
	Recv() (*Transition, error)
	grpc.ClientStream
}

type transitionServiceListClient struct {
	grpc.ClientStream
}

func (x *transitionServiceListClient) Recv() (*Transition, error) {
	m := new(Transition)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// TransitionServiceServer is the server API for TransitionService service.
// All implementations must embed UnimplementedTransitionServiceServer
// for forward compatibility
type TransitionServiceServer interface {
	Create(context.Context, *Transition) (*proto.IdRequest, error)
	Update(context.Context, *Transition) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*Transition, error)
	List(*proto.IdRequest, TransitionService_ListServer) error
	mustEmbedUnimplementedTransitionServiceServer()
}

// UnimplementedTransitionServiceServer must be embedded to have forward compatible implementations.
type UnimplementedTransitionServiceServer struct {
}

func (UnimplementedTransitionServiceServer) Create(context.Context, *Transition) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedTransitionServiceServer) Update(context.Context, *Transition) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedTransitionServiceServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedTransitionServiceServer) Get(context.Context, *proto.IdRequest) (*Transition, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedTransitionServiceServer) List(*proto.IdRequest, TransitionService_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedTransitionServiceServer) mustEmbedUnimplementedTransitionServiceServer() {}

// UnsafeTransitionServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to TransitionServiceServer will
// result in compilation errors.
type UnsafeTransitionServiceServer interface {
	mustEmbedUnimplementedTransitionServiceServer()
}

func RegisterTransitionServiceServer(s grpc.ServiceRegistrar, srv TransitionServiceServer) {
	s.RegisterService(&TransitionService_ServiceDesc, srv)
}

func _TransitionService_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Transition)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransitionServiceServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.TransitionService/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransitionServiceServer).Create(ctx, req.(*Transition))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransitionService_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Transition)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransitionServiceServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.TransitionService/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransitionServiceServer).Update(ctx, req.(*Transition))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransitionService_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransitionServiceServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.TransitionService/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransitionServiceServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransitionService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TransitionServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.TransitionService/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TransitionServiceServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _TransitionService_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(proto.IdRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(TransitionServiceServer).List(m, &transitionServiceListServer{stream})
}

type TransitionService_ListServer interface {
	Send(*Transition) error
	grpc.ServerStream
}

type transitionServiceListServer struct {
	grpc.ServerStream
}

func (x *transitionServiceListServer) Send(m *Transition) error {
	return x.ServerStream.SendMsg(m)
}

// TransitionService_ServiceDesc is the grpc.ServiceDesc for TransitionService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var TransitionService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.TransitionService",
	HandlerType: (*TransitionServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _TransitionService_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _TransitionService_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _TransitionService_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _TransitionService_Get_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _TransitionService_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "stateMachineServices.proto",
}
